=== tangent/CMakeLists.txt ===
set(_subdirs gtkutil json util tooling)
foreach(subdir ${_subdirs})
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${subdir}/CMakeLists.txt)
    add_subdirectory(${subdir})
  endif()
endforeach()
