=== debian/changelog ===
cmake-format (0.6.10-2) unstable; urgency=medium

  * Remove stray debug from debian/rules
  * Include upstream URL in manpages
  * Correct repository on salsa.

 -- Ian Campbell <ijc@debian.org>  Sat, 13 Jun 2020 11:03:42 +0100

cmake-format (0.6.10-1) unstable; urgency=medium

  * Initial packaging. (Closes: #958806)

 -- Ian Campbell <ijc@debian.org>  Fri, 01 May 2020 14:05:22 +0800
