=== debian/control ===
Source: cmake-format
Maintainer: Ian Campbell <ijc@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-python,
               dh-sequence-python3,
               cmake,
               python3,
               python3-setuptools,
               python3-six,
               python3-argparse-manpage
Standards-Version: 4.5.0.1
Vcs-Browser: https://salsa.debian.org/debian/cmake_format
Vcs-Git: https://salsa.debian.org/debian/cmake_format.git
Homepage: https://github.com/cheshirekow/cmake_format
Rules-Requires-Root: no

Package: cmake-format
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         python3-pkg-resources
Recommends: python3-jinja2
Description: source code formatter for cmake listfiles
 Contains several utilities for formatting and linting cmake
 configuration files.
 .
  * cmake-annotate can generate pretty HTML from your
    listfiles.
  * cmake-format can format your listfiles nicely.
  * cmake-lint can check your listfiles for problems
