=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	# Force pybuild otherwise makefile is used.
	dh $@ --buildsystem=pybuild

GEN_MANPAGE := PYTHONPATH=$(CURDIR) argparse-manpage  --function get_argparser --author='Josh Bialkowski' --author-email=josh.bialkowski@gmail.com --url=https://github.com/cheshirekow/cmake_format
override_dh_auto_install:
	dh_auto_install

	mkdir -p debian/cmake-format/usr/share/man/man1
	$(GEN_MANPAGE) --project-name=cmake-format     --pyfile ./cmake_format/__main__.py   --output debian/cmake-format/usr/share/man/man1/cmake-format.1
	$(GEN_MANPAGE) --project-name=cmake-annotate   --pyfile ./cmake_format/annotate.py   --output debian/cmake-format/usr/share/man/man1/cmake-annotate.1
	$(GEN_MANPAGE) --project-name=cmake-genparsers --pyfile ./cmake_format/genparsers.py --output debian/cmake-format/usr/share/man/man1/cmake-genparsers.1
	$(GEN_MANPAGE) --project-name=cmake-lint       --pyfile ./cmake_lint/__main__.py     --output debian/cmake-format/usr/share/man/man1/cmake-lint.1

override_dh_auto_test:
	PYBUILD_TEST_BASE_OVERRIDE=$(CURDIR) dh_auto_test
