=== cmake_format/doc/CMakeLists.txt ===
--- 
+++ 
@@ -208,25 +208,25 @@
 foreach(genfile ${_insource_genfiles})
   add_custom_command(
     OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
-    COMMAND python -Bm cmake_format.doc.gendoc --bits ${_stage}/bits
+    COMMAND python -B ${TANGENT_TOOLING}/gendoc.py --bits ${_stage}/bits
             ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
     # TODO(josh): not every file depends on every bit, so this is overkill, but
     # whatever... it's fine for now. We'll need more complicated code if we want
     # to actually declare which bits each file depends on.
-    DEPENDS ${_genbits} gendoc.py
+    DEPENDS ${_genbits} ${TANGENT_TOOLING}/gendoc.py
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
   list(APPEND _genfiles ${CMAKE_CURRENT_SOURCE_DIR}/${genfile})
 
   add_custom_target(
     run.cmake_format-doc-verify-${genfile}
-    COMMAND python -Bm cmake_format.doc.gendoc --verify --bits ${_stage}/bits
-            ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
+    COMMAND python -B ${TANGENT_TOOLING}/gendoc.py --verify --bits
+            ${_stage}/bits ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 
   add_test(
     NAME cmake_format-doc-verify-${genfile}
-    COMMAND python -Bm cmake_format.doc.gendoc --verify --bits ${_stage}/bits
-            ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
+    COMMAND python -B ${TANGENT_TOOLING}/gendoc.py --verify --bits
+            ${_stage}/bits ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 endforeach()
 add_custom_target(genbits-cmake_format DEPENDS ${_genbits})
@@ -257,6 +257,7 @@
     index.rst
     installation.rst
     lint-example.rst
+    lint-inline.rst
     lint-notes.rst
     lint-summary.rst
     lint-usage.rst
@@ -295,9 +296,12 @@
 
 add_custom_command(
   OUTPUT ${_stage}/rtd-requirements.txt
-  COMMAND python -Bm cmake_format.tools.gen_rtd_requirements \$\${TRAVIS_TAG}
-          ${_src_version} -o ${_stage}/rtd-requirements.txt
-  DEPENDS ${CMAKE_SOURCE_DIR}/cmake_format/tools/gen_rtd_requirements.py
+  COMMAND
+    python -B ${TANGENT_TOOLING}/gen_rtd_requirements.py --tag from-travis
+    --version ${_src_version} -o ${_stage}/rtd-requirements.txt
+    ${CMAKE_CURRENT_SOURCE_DIR}/rtd-requirements.txt.in
+  DEPENDS ${TANGENT_TOOLING}/gen_rtd_requirements.py
+          ${CMAKE_CURRENT_SOURCE_DIR}/rtd-requirements.txt.in
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 list(APPEND _genbits ${_stage}/rtd-requirements.txt)
 
@@ -315,7 +319,7 @@
 add_custom_target(
   clean-cmake_format-sphinx-stage
   DEPENDS ${_sphinx_manifest} ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST
-  COMMAND python -Bm tangent.tooling.clean_stage
+  COMMAND python -B ${TANGENT_TOOLING}/clean_stage.py
           ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST ${_stage}
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
   COMMENT "Cleaning cmake_format/doc/stage")
@@ -325,6 +329,3 @@
   COMMAND env PYTHONPATH=${CMAKE_SOURCE_DIR} sphinx-build -M html ${_stage}
           ${CMAKE_CURRENT_BINARY_DIR}
   COMMAND touch ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
-  DEPENDS clean-cmake_format-sphinx-stage ${_sphinx_manifest}
-          ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST ${CMAKE_SOURCE_DIR}/doc/conf.py
-  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
