=== debian/changelog ===
cmake-format (0.6.11-1) unstable; urgency=medium

  * New upstream release.
  * Recomment python3-argcomplete since upstream now supports it.

 -- Ian Campbell <ijc@debian.org>  Sat, 18 Jul 2020 11:54:04 +0100

cmake-format (0.6.10-3) unstable; urgency=medium

  * Ensure pybuild chooses to use the disttools plugin (Closes: #963294).

 -- Ian Campbell <ijc@debian.org>  Sat, 27 Jun 2020 08:10:41 +0100
